using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace zad2
{
    class Program
    {
        static void Main(string[] args)
        {
            int n;
            int[] koliko = new int[4];
            n = Convert.ToInt32(Console.ReadLine());
            string[] pacijenti = new string[n];
            int[] potrebe = new int[n];
            int[,] resenje = new int[4, n];
            string[] ulaz1 = Console.ReadLine().Split();
            koliko[0] = int.Parse(ulaz1[0]);
            koliko[1] = int.Parse(ulaz1[1]);
            koliko[2] = int.Parse(ulaz1[2]);
            koliko[3] = int.Parse(ulaz1[3]);
            bool moguce = true;

            for (int i = 0; i < n; i++)
            {
                ulaz1 = Console.ReadLine().Split();
                pacijenti[i] = ulaz1[0];
                potrebe[i] = int.Parse(ulaz1[1]);
                for (int j = 0; j < 4; j++)
                {
                    resenje[j, i] = 0;
                }
            }


            for (int i = 0; i < n; i++)
            {
                if (pacijenti[i] == "O")
                {
                    if (potrebe[i] > koliko[0]) { moguce = false; }
                    else
                    {
                        koliko[0] = koliko[0] - potrebe[i];
                        resenje[0, i] = potrebe[i];
                    }
                }
            }

            if (moguce == true)
            {
                for (int i = 0; i < n; i++)
                {
                    if (pacijenti[i] == "A")
                    {
                        if (potrebe[i] <= koliko[1])
                        {
                            koliko[1] = koliko[1] - potrebe[i];
                            resenje[1, i] = potrebe[i];
                        }
                        else if (koliko[1] > 0)
                        {
                            potrebe[i] = potrebe[i] - koliko[1];
                            resenje[1, i] = koliko[1];
                            koliko[1] = 0;
                            if (potrebe[i] < koliko[0])
                            {
                                koliko[0] = koliko[0] - potrebe[i];
                                resenje[0, i] = potrebe[i];
                            }
                            else { moguce = false; }
                        }
                        else
                        {
                            if (potrebe[i] > koliko[0]) { moguce = false; }
                            else
                            {
                                koliko[0] = koliko[0] - potrebe[i];
                                resenje[0, i] = potrebe[i];
                            }
                        }
                    }
                    else if (pacijenti[i] == "B")
                    {
                        if (potrebe[i] <= koliko[2])
                        {
                            koliko[2] = koliko[2] - potrebe[i];
                            resenje[2, i] = potrebe[i];
                        }
                        else if (koliko[2] > 0)
                        {
                            potrebe[i] = potrebe[i] - koliko[2];
                            resenje[2, i] = koliko[2];
                            koliko[2] = 0;
                            if (potrebe[i] <= koliko[0])
                            {
                                koliko[0] = koliko[0] - potrebe[i];
                                resenje[0, i] = potrebe[i];
                            }
                            else { moguce = false; }
                        }
                        else
                        {
                            if (potrebe[i] > koliko[0]) { moguce = false; }
                            else
                            {
                                koliko[0] = koliko[0] - potrebe[i];
                                resenje[0, i] = potrebe[i];
                            }
                        }
                    }
                }
            }

            if (moguce == true)
            {
                for (int i = 0; i < n; i++)
                {
                    if (pacijenti[i] == "AB")
                    {
                        if (potrebe[i] < koliko[3])
                        {
                            resenje[3, i] = potrebe[i];
                            koliko[3] = koliko[3] - potrebe[i];
                        }
                        else
                        {
                            if (koliko[3] > 0)
                            {
                                resenje[3, i] = koliko[3];
                                potrebe[i] = potrebe[i] - koliko[3];
                                koliko[3] = 0;
                            }
                            if (potrebe[i] <= koliko[2])
                            {
                                resenje[2, i] = koliko[2];
                                koliko[2] = koliko[2] - potrebe[i];
                            }
                            else
                            {
                                if (koliko[2] > 0)
                                {
                                    resenje[2, i] = koliko[2];
                                    potrebe[i] = potrebe[i] - koliko[2];
                                    koliko[2] = 0;
                                }
                                if (potrebe[i] <= koliko[1])
                                {
                                    resenje[1, i] = potrebe[1];
                                    koliko[1] = koliko[1] - potrebe[i];
                                }
                                else
                                {
                                    if (koliko[i] > 0)
                                    {
                                        resenje[1, i] = koliko[1];
                                        potrebe[i] = potrebe[i] - koliko[1];
                                        koliko[1] = 0;
                                    }
                                    if (potrebe[i] <= koliko[0])
                                    {
                                        resenje[0, i] = potrebe[i];
                                        koliko[0] = koliko[0] - potrebe[i];
                                    }
                                    else { moguce = false; }
                                }
                            }
                            
                        }

                    }
                }
            }


            if (moguce == false) { Console.WriteLine("nemoguce"); }
            else
            {
                Console.WriteLine("moguce");
                for (int i = 0; i < n; i++)
                {
                    Console.Write(resenje[0, i]);
                    Console.Write(" ");
                    Console.Write(resenje[1, i]);
                    Console.Write(" ");
                    Console.Write(resenje[2, i]);
                    Console.Write(" ");
                    Console.WriteLine(resenje[3, i]);
                }
            }
            Console.ReadLine();
        }
    }
}